<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\ItemModel;
use App\Http\Models\PenerimaanbarangModel;
use App\Http\Models\StgpelniscmrcvtrxintModel;
use App\Http\Models\StgpelniscmrcvintModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class PenerimaanbarangService extends BaseService
{
	/**
     PenerimaanbarangService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PenerimaanbarangModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		$this->model->joinRelationVoyageKode()->joinRelationLocationId()->joinRelationUserId()->getQuery()->select([
			"penerimaanbarang.poNumber as poNumber",
			"locationId.id as locationId",
			"userId.id as userId",
			"penerimaanbarang.receiptNumber as receiptNumber",
			"penerimaanbarang.receiptDate as receiptDate",
			"penerimaanbarang.voyageKode as voyageKode",
			"penerimaanbarang.voyageStart as voyageStart",
			"penerimaanbarang.voyageEnd as voyageEnd",
			"voyageKode.voyageName as voyageName"
		]);

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("penerimaanbarang.kapalId", "=", $auth->kapalId);
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PenerimaanbarangModel
	 */
	public function show($id)
	{
		$model = 	$this->model->joinRelationVoyageKode()->getQuery()
			->select(["penerimaanbarang.*", "penerimaanbarang.poNumber as headerNumber", "penerimaanbarang.receiptNumber as detailNumber", "voyageKode.voyageName"])
			->where("penerimaanbarang.id", "=", $id)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PenerimaanbarangModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$qtyDiterima = 0;
		if (isset($input["itemID"])) {
			$qtyDiterima = array_sum($input["quantity"]);
		}

		$input["locationId"] = 1;
		$input["qtyDiterima"] = $qtyDiterima;

		$transactionBrg = new PenerimaanbarangModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}

	public function getPrepareUpdateStock($input)
	{
		$data = [];
		$tglMasuk = date("Y-m-d H:i:s");
		if (isset($input["itemID"]) && !empty($input["itemID"])) {
			foreach ($input["itemID"] as $idx => $value) {
				$item = (new ItemModel())->where("id", "=", $value)->first();
				if ($item->stockable == "Y") {
					$data[] = [
						"itemId" => $value,
						"kapalId" => $input["kapalId"],
						"lokasiId" => $input["lokasiId"][$value],
						"jumlah" => $input["quantity"][$value],
						"satuan" => "",
						"status" => 1,
						"type" => 1,
						"lotNumber" => $input["lotNumber"][$value],
						"tglMasuk" => $input["tanggalPenerimaan"],
						"harga_satuan" => $input["harga_satuan"][$value],

						// ADDITION FOR STOCK HISTORY
						"transaksi" => "penerimaanbarang",
						"noTransaksi" => $input["refId"],
						"username" => $input["username"],
						"periode" => $input["tanggalPenerimaan"]

					];
				}
			}
		}
		return $data;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PenerimaanbarangModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$penerimaanbarang = PenerimaanbarangModel::find($id);
		// $penerimaanbarang->fill($input);
		$penerimaanbarang->qtyDiterima = $input["qtyDiterima"];
		if (!$penerimaanbarang->save()) {
			throw new \Exception();
		}
		return $penerimaanbarang;
	}

	public function updateQty($pbNumber, $qty)
	{
		$penerimaanbarang = $this->model->getQuery()->where("receiptNumber", "=", $pbNumber)->first();
		if (!$penerimaanbarang) {
			throw new \Exception();
		} else {
			$qty = $penerimaanbarang->qtyDiterima + $qty;
			if ($qty < 0) {
				$qty = 0;
			}
			$this->update($penerimaanbarang->id, ["qtyDiterima" => $qty]);
		}
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function showBasedOnPoNumber($request, $popenerimaan)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->getQuery()
			->select([
				"penerimaanbarang.id as id",
				"penerimaanbarang.receiptNumber as receiptNumber",
				"penerimaanbarang.tanggalPenerimaan as tanggalPenerimaan",
				"penerimaanbarang.status as status",
				"penerimaanbarang.qtyDiterima as qtyDiterima"
			])
			->where("penerimaanbarang.kapalId", "=", $popenerimaan->kapalId)
			->where("penerimaanbarang.poNumber", "=", $popenerimaan->poNumber)
			->orderBy("penerimaanbarang.receiptNumber", "desc");

		$this->model->getQuery()->whereIn('penerimaanbarang.receiptNumber', function ($query) use ($auth) {
			$query->select('itempenerimaanbarang.penerimaanBarangId')
				->from('itempenerimaanbarang')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itempenerimaanbarang.itemId");
					$join->on("item.kapalId", "=", "penerimaanbarang.kapalId");
				})
				// "item.id", "=", "itempenerimaanbarang.itemId")
				->whereIn("item.type_id", $auth->arrCategory)
				->whereIn("itempenerimaanbarang.lokasiId", $auth->arrLokasi);
		});

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
		// return $model;
	}


	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("penerimaanbarang"."receiptNumber", 9, 6)) AS "receiptNumber"')->where("penerimaanbarang.receiptNumber", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->receiptNumber + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}

	public function saveStaging($input)
	{
		$data = [];
		$dateNow = date("Y-m-d");
		$totalLine = count($input["itemID"]);

		foreach ($input["itemID"] as $itemID) {
			$data[] =  [
				"transaction_number"		=> $input["receiptNumber"],
				"item_id"					=> $itemID,
				"item_segment1"				=> $input["namaItem"][$itemID],
				"transaction_date"			=> $input["tanggalPenerimaan"],
				"quantity"					=> $input["quantity"][$itemID],
				"ship_to_location_code" 	=> $input["namaLokasi"][$itemID],
				"attribute2"				=> $input["lotNumber"][$itemID],
				"voyage_call"				=> $input["voyageKode"],
				"last_update_date"			=> $dateNow,
				"creation_date"				=> $dateNow,
				"transaction_type"			=> "RECEIVE",
				"processing_status_code"	=> "PENDING",
				"transaction_status_code"	=> "PENDING",
				"processing_mode_code"		=> "PENDING",

				"total_line"				=> $totalLine
			];
		}

		/* $stagingTrxModel = new StgpelniscmrcvtrxintModel();
		if(! $stagingTrxModel->save($data)) {
			throw new \Exception();
		} */
		foreach ($data as $dat) {
			$stagingModel = new StgpelniscmrcvtrxintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}

		$data2 = [

			"transaction_number"		=> $input["receiptNumber"],
			"vendor_id"					=> $input["vendorId"],
			"vendor_name"				=> $input["vendorName"],
			"transfer_date"				=> $input["tanggalPenerimaan"],
			"processing_status_code"	=> "PENDING",
			"receipt_source_code"		=> "VENDOR",
			"transaction_type"			=> "NEW",
			"validation_flag"			=> "Y",
			"auto_transact_code"		=> "RECEIVE",
			"attribute1"				=> $input["poNumber"],
			"attribute14"				=> $input["jabatan"],

			"total_line"				=> $totalLine
		];

		$stagingModel = new StgpelniscmrcvintModel();
		$stagingModel->fill($data2);
		if (!$stagingModel->save()) {
			throw new \Exception();
		}
	}

	public function getItemPenerimaanBasedOnVoyage($itemID, $voyageKode, $dateFrom = "", $dateTo = "")
	{
		$model = (new PenerimaanbarangModel())->joinRelationItemPenerimaanBarangId()->getQuery()
			->where("itempenerimaanbarang.itemId", "=", $itemID)
			->where("penerimaanbarang.voyageKode", "=", $voyageKode)
			->where("penerimaanbarang.tanggalPenerimaan", ">=", $dateFrom)
			->where("penerimaanbarang.tanggalPenerimaan", "<=", $dateTo)
			->get();
		return $model;
	}
}
